/* Automatically generated by refactor.pl.
 *
 *
 * CMDNAME: unbanall
 * CMDLEVEL: QCMD_AUTHED
 * CMDARGS: 1
 * CMDDESC: Removes all bans from a channel.
 * CMDFUNC: csc_dounbanall
 * CMDPROTO: int csc_dounbanall(void *source, int cargc, char **cargv);
 * CMDHELP: Usage: UNBANALL <channel>
 * CMDHELP: Removes all the channel bans set on the named channel.  This does not affect
 * CMDHELP: persistent bans set via the TEMPBAN and PERMBAN commands, see BANCLEAR or
 * CMDHELP: BANDEL for more information on removing those bans.  Where:
 * CMDHELP: channel - channel to use
 * CMDHELP: UNBANALL requires master (+m) access on the named channel.
 */

#include "../chanserv.h"
#include "../../nick/nick.h"
#include "../../lib/flags.h"
#include "../../lib/irc_string.h"
#include "../../channel/channel.h"
#include "../../parser/parser.h"
#include "../../irc/irc.h"
#include "../../localuser/localuserchannel.h"
#include <string.h>
#include <stdio.h>

int csc_dounbanall(void *source, int cargc, char **cargv) {
  nick *sender=source;
  chanindex *cip;
  modechanges changes;

  if (cargc<1) {
    chanservstdmessage(sender, QM_NOTENOUGHPARAMS, "unbanall");
    return CMD_ERROR;
  }

  if (!(cip=cs_checkaccess(sender, cargv[0], CA_MASTERPRIV, NULL, "unbanall",0, 0)))
    return CMD_ERROR;

  if (cip->channel) {
    localsetmodeinit(&changes, cip->channel, chanservnick);

    while (cip->channel->bans) {
      localdosetmode_ban(&changes, bantostring(cip->channel->bans), MCB_DEL);
    }

    localsetmodeflush(&changes, 1);
  }

  cs_log(sender,"UNBANALL %s",cip->name->content);
  chanservstdmessage(sender, QM_DONE);
  return CMD_OK;
}     
